# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError

from typing_extensions import Annotated
from pydantic import Field, StrictInt, StrictStr

from typing import List, Optional

from redrover_api.models.absence_reason_balance_create_request import AbsenceReasonBalanceCreateRequest
from redrover_api.models.absence_reason_balance_response import AbsenceReasonBalanceResponse
from redrover_api.models.absence_reason_balance_update_request import AbsenceReasonBalanceUpdateRequest
from redrover_api.models.ok_object_result import OkObjectResult

from redrover_api.api_client import ApiClient
from redrover_api.api_response import ApiResponse
from redrover_api.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class AbsenceReasonBalanceApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def create_absence_reason_balance(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], employee_identifier : Annotated[StrictStr, Field(..., description="The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], absence_reason_balance_create_request : Optional[AbsenceReasonBalanceCreateRequest] = None, **kwargs) -> AbsenceReasonBalanceResponse:  # noqa: E501
        """Create Absence Reason Balance  # noqa: E501

        Create new Absence Reason Balance for an Employee  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_absence_reason_balance(org_id, employee_identifier, absence_reason_balance_create_request, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param employee_identifier: The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type employee_identifier: str
        :param absence_reason_balance_create_request:
        :type absence_reason_balance_create_request: AbsenceReasonBalanceCreateRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: AbsenceReasonBalanceResponse
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the create_absence_reason_balance_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.create_absence_reason_balance_with_http_info(org_id, employee_identifier, absence_reason_balance_create_request, **kwargs)  # noqa: E501

    @validate_arguments
    def create_absence_reason_balance_with_http_info(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], employee_identifier : Annotated[StrictStr, Field(..., description="The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], absence_reason_balance_create_request : Optional[AbsenceReasonBalanceCreateRequest] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Create Absence Reason Balance  # noqa: E501

        Create new Absence Reason Balance for an Employee  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_absence_reason_balance_with_http_info(org_id, employee_identifier, absence_reason_balance_create_request, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param employee_identifier: The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type employee_identifier: str
        :param absence_reason_balance_create_request:
        :type absence_reason_balance_create_request: AbsenceReasonBalanceCreateRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(AbsenceReasonBalanceResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'org_id',
            'employee_identifier',
            'absence_reason_balance_create_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_absence_reason_balance" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['org_id'] is not None:
            _path_params['orgId'] = _params['org_id']

        if _params['employee_identifier'] is not None:
            _path_params['employeeIdentifier'] = _params['employee_identifier']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['absence_reason_balance_create_request'] is not None:
            _body_params = _params['absence_reason_balance_create_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['apiKey']  # noqa: E501

        _response_types_map = {
            '200': "AbsenceReasonBalanceResponse",
            '400': "BadRequestResult",
            '401': None,
            '404': "NotFoundResult",
        }

        return self.api_client.call_api(
            '/api/v1/{orgId}/Employee/{employeeIdentifier}/absenceReasonBalances', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def delete_absence_reason_balance(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], employee_identifier : Annotated[StrictStr, Field(..., description="The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], id : Annotated[StrictInt, Field(..., description="The id of the AbsenceReasonBalance")], **kwargs) -> OkObjectResult:  # noqa: E501
        """Delete Absence Reason Balance  # noqa: E501

        Delete an Absence Reason Balance for an Employee by its Red Rover Id (numeric)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_absence_reason_balance(org_id, employee_identifier, id, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param employee_identifier: The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type employee_identifier: str
        :param id: The id of the AbsenceReasonBalance (required)
        :type id: int
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: OkObjectResult
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the delete_absence_reason_balance_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.delete_absence_reason_balance_with_http_info(org_id, employee_identifier, id, **kwargs)  # noqa: E501

    @validate_arguments
    def delete_absence_reason_balance_with_http_info(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], employee_identifier : Annotated[StrictStr, Field(..., description="The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], id : Annotated[StrictInt, Field(..., description="The id of the AbsenceReasonBalance")], **kwargs) -> ApiResponse:  # noqa: E501
        """Delete Absence Reason Balance  # noqa: E501

        Delete an Absence Reason Balance for an Employee by its Red Rover Id (numeric)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_absence_reason_balance_with_http_info(org_id, employee_identifier, id, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param employee_identifier: The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type employee_identifier: str
        :param id: The id of the AbsenceReasonBalance (required)
        :type id: int
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(OkObjectResult, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'org_id',
            'employee_identifier',
            'id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_absence_reason_balance" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['org_id'] is not None:
            _path_params['orgId'] = _params['org_id']

        if _params['employee_identifier'] is not None:
            _path_params['employeeIdentifier'] = _params['employee_identifier']

        if _params['id'] is not None:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['apiKey']  # noqa: E501

        _response_types_map = {
            '200': "OkObjectResult",
            '401': None,
            '404': "NotFoundResult",
        }

        return self.api_client.call_api(
            '/api/v1/{orgId}/Employee/{employeeIdentifier}/absenceReasonBalances/{id}', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def get_absence_reason_balance(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], employee_identifier : Annotated[StrictStr, Field(..., description="The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], id : Annotated[StrictInt, Field(..., description="The id of the AbsenceReasonBalance")], **kwargs) -> AbsenceReasonBalanceResponse:  # noqa: E501
        """Get Absence Reason Balance  # noqa: E501

        Gets a specific Absence Reason Balance by its Red Rover Id  (numeric)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_absence_reason_balance(org_id, employee_identifier, id, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param employee_identifier: The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type employee_identifier: str
        :param id: The id of the AbsenceReasonBalance (required)
        :type id: int
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: AbsenceReasonBalanceResponse
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_absence_reason_balance_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_absence_reason_balance_with_http_info(org_id, employee_identifier, id, **kwargs)  # noqa: E501

    @validate_arguments
    def get_absence_reason_balance_with_http_info(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], employee_identifier : Annotated[StrictStr, Field(..., description="The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], id : Annotated[StrictInt, Field(..., description="The id of the AbsenceReasonBalance")], **kwargs) -> ApiResponse:  # noqa: E501
        """Get Absence Reason Balance  # noqa: E501

        Gets a specific Absence Reason Balance by its Red Rover Id  (numeric)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_absence_reason_balance_with_http_info(org_id, employee_identifier, id, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param employee_identifier: The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type employee_identifier: str
        :param id: The id of the AbsenceReasonBalance (required)
        :type id: int
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(AbsenceReasonBalanceResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'org_id',
            'employee_identifier',
            'id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_absence_reason_balance" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['org_id'] is not None:
            _path_params['orgId'] = _params['org_id']

        if _params['employee_identifier'] is not None:
            _path_params['employeeIdentifier'] = _params['employee_identifier']

        if _params['id'] is not None:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['apiKey']  # noqa: E501

        _response_types_map = {
            '200': "AbsenceReasonBalanceResponse",
            '401': None,
            '404': "NotFoundResult",
        }

        return self.api_client.call_api(
            '/api/v1/{orgId}/Employee/{employeeIdentifier}/absenceReasonBalances/{id}', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def get_absence_reason_balances(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], employee_identifier : Annotated[StrictStr, Field(..., description="The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], school_year_id : Annotated[Optional[StrictInt], Field(description="Filter by school year (optional)")] = None, **kwargs) -> List[AbsenceReasonBalanceResponse]:  # noqa: E501
        """Get Absence Reason Balances  # noqa: E501

        Get Absence Reason Balance for an employee  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_absence_reason_balances(org_id, employee_identifier, school_year_id, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param employee_identifier: The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type employee_identifier: str
        :param school_year_id: Filter by school year (optional)
        :type school_year_id: int
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: List[AbsenceReasonBalanceResponse]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_absence_reason_balances_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_absence_reason_balances_with_http_info(org_id, employee_identifier, school_year_id, **kwargs)  # noqa: E501

    @validate_arguments
    def get_absence_reason_balances_with_http_info(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], employee_identifier : Annotated[StrictStr, Field(..., description="The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], school_year_id : Annotated[Optional[StrictInt], Field(description="Filter by school year (optional)")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Get Absence Reason Balances  # noqa: E501

        Get Absence Reason Balance for an employee  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_absence_reason_balances_with_http_info(org_id, employee_identifier, school_year_id, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param employee_identifier: The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type employee_identifier: str
        :param school_year_id: Filter by school year (optional)
        :type school_year_id: int
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(List[AbsenceReasonBalanceResponse], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'org_id',
            'employee_identifier',
            'school_year_id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_absence_reason_balances" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['org_id'] is not None:
            _path_params['orgId'] = _params['org_id']

        if _params['employee_identifier'] is not None:
            _path_params['employeeIdentifier'] = _params['employee_identifier']


        # process the query parameters
        _query_params = []
        if _params.get('school_year_id') is not None:  # noqa: E501
            _query_params.append(('schoolYearId', _params['school_year_id']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['apiKey']  # noqa: E501

        _response_types_map = {
            '200': "List[AbsenceReasonBalanceResponse]",
            '401': None,
            '404': "NotFoundResult",
        }

        return self.api_client.call_api(
            '/api/v1/{orgId}/Employee/{employeeIdentifier}/absenceReasonBalances', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def update_absence_reason_balance(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], employee_identifier : Annotated[StrictStr, Field(..., description="The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], id : Annotated[StrictInt, Field(..., description="The id of the AbsenceReasonBalance")], absence_reason_balance_update_request : Optional[AbsenceReasonBalanceUpdateRequest] = None, **kwargs) -> AbsenceReasonBalanceResponse:  # noqa: E501
        """Update Absence Reason Balance  # noqa: E501

        Update an Absence Reason Balance for an Employee by its Red Rover Id (numeric)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_absence_reason_balance(org_id, employee_identifier, id, absence_reason_balance_update_request, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param employee_identifier: The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type employee_identifier: str
        :param id: The id of the AbsenceReasonBalance (required)
        :type id: int
        :param absence_reason_balance_update_request:
        :type absence_reason_balance_update_request: AbsenceReasonBalanceUpdateRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: AbsenceReasonBalanceResponse
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the update_absence_reason_balance_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.update_absence_reason_balance_with_http_info(org_id, employee_identifier, id, absence_reason_balance_update_request, **kwargs)  # noqa: E501

    @validate_arguments
    def update_absence_reason_balance_with_http_info(self, org_id : Annotated[StrictInt, Field(..., description="The Red Rover Id of the Organization")], employee_identifier : Annotated[StrictStr, Field(..., description="The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)")], id : Annotated[StrictInt, Field(..., description="The id of the AbsenceReasonBalance")], absence_reason_balance_update_request : Optional[AbsenceReasonBalanceUpdateRequest] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Update Absence Reason Balance  # noqa: E501

        Update an Absence Reason Balance for an Employee by its Red Rover Id (numeric)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_absence_reason_balance_with_http_info(org_id, employee_identifier, id, absence_reason_balance_update_request, async_req=True)
        >>> result = thread.get()

        :param org_id: The Red Rover Id of the Organization (required)
        :type org_id: int
        :param employee_identifier: The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`) (required)
        :type employee_identifier: str
        :param id: The id of the AbsenceReasonBalance (required)
        :type id: int
        :param absence_reason_balance_update_request:
        :type absence_reason_balance_update_request: AbsenceReasonBalanceUpdateRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(AbsenceReasonBalanceResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'org_id',
            'employee_identifier',
            'id',
            'absence_reason_balance_update_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_absence_reason_balance" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['org_id'] is not None:
            _path_params['orgId'] = _params['org_id']

        if _params['employee_identifier'] is not None:
            _path_params['employeeIdentifier'] = _params['employee_identifier']

        if _params['id'] is not None:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['absence_reason_balance_update_request'] is not None:
            _body_params = _params['absence_reason_balance_update_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['apiKey']  # noqa: E501

        _response_types_map = {
            '200': "AbsenceReasonBalanceResponse",
            '401': None,
            '404': "NotFoundResult",
        }

        return self.api_client.call_api(
            '/api/v1/{orgId}/Employee/{employeeIdentifier}/absenceReasonBalances/{id}', 'PUT',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
