# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from redrover_api.models.day_part_enum import DayPartEnum
from redrover_api.models.int32_locator_request import Int32LocatorRequest
from redrover_api.models.vacancy_accounting_code_allocation_request import VacancyAccountingCodeAllocationRequest

class AbsenceVacancyDetailRequest(BaseModel):
    """
    The Vacancy Date Details  # noqa: E501
    """
    location: Optional[Int32LocatorRequest] = None
    needs_replacement: Optional[StrictBool] = Field(None, alias="needsReplacement", description="If this Vacancy needs to be open for a Substitute to fill")
    var_date: Optional[datetime] = Field(None, alias="date", description="The Date of this Detail")
    day_part_id: Optional[DayPartEnum] = Field(None, alias="dayPartId")
    start_time: Optional[StrictStr] = Field(None, alias="startTime", description="The time of day this Vacancy Detail begins")
    end_time: Optional[StrictStr] = Field(None, alias="endTime", description="The time of day this Vacancy Detail ends")
    accounting_code_allocations: Optional[conlist(VacancyAccountingCodeAllocationRequest)] = Field(None, alias="accountingCodeAllocations", description="Accounting code allocations")
    pay_code: Optional[Int32LocatorRequest] = Field(None, alias="payCode")
    replacement_employee: Optional[Int32LocatorRequest] = Field(None, alias="replacementEmployee")
    __properties = ["location", "needsReplacement", "date", "dayPartId", "startTime", "endTime", "accountingCodeAllocations", "payCode", "replacementEmployee"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AbsenceVacancyDetailRequest:
        """Create an instance of AbsenceVacancyDetailRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of location
        if self.location:
            _dict['location'] = self.location.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in accounting_code_allocations (list)
        _items = []
        if self.accounting_code_allocations:
            for _item in self.accounting_code_allocations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['accountingCodeAllocations'] = _items
        # override the default output from pydantic by calling `to_dict()` of pay_code
        if self.pay_code:
            _dict['payCode'] = self.pay_code.to_dict()
        # override the default output from pydantic by calling `to_dict()` of replacement_employee
        if self.replacement_employee:
            _dict['replacementEmployee'] = self.replacement_employee.to_dict()
        # set to None if accounting_code_allocations (nullable) is None
        # and __fields_set__ contains the field
        if self.accounting_code_allocations is None and "accounting_code_allocations" in self.__fields_set__:
            _dict['accountingCodeAllocations'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AbsenceVacancyDetailRequest:
        """Create an instance of AbsenceVacancyDetailRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AbsenceVacancyDetailRequest.parse_obj(obj)

        _obj = AbsenceVacancyDetailRequest.parse_obj({
            "location": Int32LocatorRequest.from_dict(obj.get("location")) if obj.get("location") is not None else None,
            "needs_replacement": obj.get("needsReplacement"),
            "var_date": obj.get("date"),
            "day_part_id": obj.get("dayPartId"),
            "start_time": obj.get("startTime"),
            "end_time": obj.get("endTime"),
            "accounting_code_allocations": [VacancyAccountingCodeAllocationRequest.from_dict(_item) for _item in obj.get("accountingCodeAllocations")] if obj.get("accountingCodeAllocations") is not None else None,
            "pay_code": Int32LocatorRequest.from_dict(obj.get("payCode")) if obj.get("payCode") is not None else None,
            "replacement_employee": Int32LocatorRequest.from_dict(obj.get("replacementEmployee")) if obj.get("replacementEmployee") is not None else None
        })
        return _obj


