# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from redrover_api.models.int32_locator_request import Int32LocatorRequest

class PositionScheduleCustomVariantRequest(BaseModel):
    """
    PositionScheduleCustomVariantRequest
    """
    start_time: Optional[StrictStr] = Field(None, alias="startTime", description="The start time")
    half_day_morning_end_time: Optional[StrictStr] = Field(None, alias="halfDayMorningEndTime", description="Halfday morning start time")
    half_day_afternoon_start_time: Optional[StrictStr] = Field(None, alias="halfDayAfternoonStartTime", description="Halfday afternoon start time")
    end_time: Optional[StrictStr] = Field(None, alias="endTime", description="The next end time")
    next_start_time: Optional[StrictStr] = Field(None, alias="nextStartTime", description="The next start time")
    is_work_time: Optional[StrictBool] = Field(None, alias="isWorkTime", description="If is work time")
    needs_replacement: Optional[StrictBool] = Field(None, alias="needsReplacement", description="If needs replacement")
    needs_replacement_am: Optional[StrictBool] = Field(None, alias="needsReplacementAm", description="If needs replacement for AM")
    needs_replacement_pm: Optional[StrictBool] = Field(None, alias="needsReplacementPm", description="If needs replacement for PM")
    work_day_schedule_variant_type: Optional[Int32LocatorRequest] = Field(None, alias="workDayScheduleVariantType")
    __properties = ["startTime", "halfDayMorningEndTime", "halfDayAfternoonStartTime", "endTime", "nextStartTime", "isWorkTime", "needsReplacement", "needsReplacementAm", "needsReplacementPm", "workDayScheduleVariantType"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PositionScheduleCustomVariantRequest:
        """Create an instance of PositionScheduleCustomVariantRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of work_day_schedule_variant_type
        if self.work_day_schedule_variant_type:
            _dict['workDayScheduleVariantType'] = self.work_day_schedule_variant_type.to_dict()
        # set to None if start_time (nullable) is None
        # and __fields_set__ contains the field
        if self.start_time is None and "start_time" in self.__fields_set__:
            _dict['startTime'] = None

        # set to None if half_day_morning_end_time (nullable) is None
        # and __fields_set__ contains the field
        if self.half_day_morning_end_time is None and "half_day_morning_end_time" in self.__fields_set__:
            _dict['halfDayMorningEndTime'] = None

        # set to None if half_day_afternoon_start_time (nullable) is None
        # and __fields_set__ contains the field
        if self.half_day_afternoon_start_time is None and "half_day_afternoon_start_time" in self.__fields_set__:
            _dict['halfDayAfternoonStartTime'] = None

        # set to None if end_time (nullable) is None
        # and __fields_set__ contains the field
        if self.end_time is None and "end_time" in self.__fields_set__:
            _dict['endTime'] = None

        # set to None if next_start_time (nullable) is None
        # and __fields_set__ contains the field
        if self.next_start_time is None and "next_start_time" in self.__fields_set__:
            _dict['nextStartTime'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PositionScheduleCustomVariantRequest:
        """Create an instance of PositionScheduleCustomVariantRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PositionScheduleCustomVariantRequest.parse_obj(obj)

        _obj = PositionScheduleCustomVariantRequest.parse_obj({
            "start_time": obj.get("startTime"),
            "half_day_morning_end_time": obj.get("halfDayMorningEndTime"),
            "half_day_afternoon_start_time": obj.get("halfDayAfternoonStartTime"),
            "end_time": obj.get("endTime"),
            "next_start_time": obj.get("nextStartTime"),
            "is_work_time": obj.get("isWorkTime"),
            "needs_replacement": obj.get("needsReplacement"),
            "needs_replacement_am": obj.get("needsReplacementAm"),
            "needs_replacement_pm": obj.get("needsReplacementPm"),
            "work_day_schedule_variant_type": Int32LocatorRequest.from_dict(obj.get("workDayScheduleVariantType")) if obj.get("workDayScheduleVariantType") is not None else None
        })
        return _obj


