# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr, conlist
from redrover_api.models.accounting_code_allocation_response import AccountingCodeAllocationResponse
from redrover_api.models.approval_status_enum import ApprovalStatusEnum
from redrover_api.models.int32_id_name_class import Int32IdNameClass
from redrover_api.models.pay_code_response import PayCodeResponse
from redrover_api.models.simple_absence_detail import SimpleAbsenceDetail
from redrover_api.models.simple_person import SimplePerson
from redrover_api.models.simple_position import SimplePosition

class VacancyDetailSearchResponse(BaseModel):
    """
    Vacancy Detail  # noqa: E501
    """
    notes_to_admin: Optional[StrictStr] = Field(None, alias="notesToAdmin", description="Any notes to the admin")
    admin_only_notes: Optional[StrictStr] = Field(None, alias="adminOnlyNotes", description="Notes made by the admin")
    absence_detail: Optional[SimpleAbsenceDetail] = Field(None, alias="absenceDetail")
    vacancy_id: Optional[StrictInt] = Field(None, alias="vacancyId", description="Id of the Vacancy")
    is_deleted: Optional[StrictBool] = Field(None, alias="isDeleted", description="If the vacancy was deleted")
    position: Optional[SimplePosition] = None
    created_utc: Optional[datetime] = Field(None, alias="createdUtc", description="When the Vacancy Detail was created")
    id: Optional[StrictInt] = Field(None, description="Id of the Vacancy Detail")
    assignment_id: Optional[StrictInt] = Field(None, alias="assignmentId", description="Id of the Assignment")
    substitute: Optional[SimplePerson] = None
    external_assignment_number: Optional[StrictStr] = Field(None, alias="externalAssignmentNumber", description="Assignment number to match another system")
    assignment_is_long_term: Optional[StrictBool] = Field(None, alias="assignmentIsLongTerm", description="Is this assignment considered long term?")
    assignment_notes: Optional[StrictStr] = Field(None, alias="assignmentNotes", description="Notes about this assignment")
    location: Optional[Int32IdNameClass] = None
    start: Optional[datetime] = Field(None, description="When the Vacancy starts")
    end: Optional[datetime] = Field(None, description="When the Vacancy ends")
    actual_duration_minutes: Optional[StrictInt] = Field(None, alias="actualDurationMinutes", description="How long the Vacancy Detail is scheduled (minutes)")
    accounting_codes: Optional[conlist(AccountingCodeAllocationResponse)] = Field(None, alias="accountingCodes", description="The Accounting codes associated with the Vacancy")
    pay_duration: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="payDuration", description="The Calculated Effective Duration (Days or Minutes)")
    pay_unit: Optional[StrictStr] = Field(None, alias="payUnit", description="The pay unit. ('DAYS', 'MINUTES')")
    pay_code: Optional[PayCodeResponse] = Field(None, alias="payCode")
    vacancy_reason: Optional[Int32IdNameClass] = Field(None, alias="vacancyReason")
    verified: Optional[StrictBool] = Field(None, description="If the Vacancy has been verified")
    verified_at_utc: Optional[datetime] = Field(None, alias="verifiedAtUtc", description="When the Vacancy was verified")
    verify_comment: Optional[StrictStr] = Field(None, alias="verifyComment", description="Comment made when the Vacancy was verified")
    verified_by: Optional[Int32IdNameClass] = Field(None, alias="verifiedBy")
    approval_status: Optional[StrictStr] = Field(None, alias="approvalStatus", description="The current approval status of the vacancy")
    approval_status_id: Optional[ApprovalStatusEnum] = Field(None, alias="approvalStatusId")
    __properties = ["notesToAdmin", "adminOnlyNotes", "absenceDetail", "vacancyId", "isDeleted", "position", "createdUtc", "id", "assignmentId", "substitute", "externalAssignmentNumber", "assignmentIsLongTerm", "assignmentNotes", "location", "start", "end", "actualDurationMinutes", "accountingCodes", "payDuration", "payUnit", "payCode", "vacancyReason", "verified", "verifiedAtUtc", "verifyComment", "verifiedBy", "approvalStatus", "approvalStatusId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> VacancyDetailSearchResponse:
        """Create an instance of VacancyDetailSearchResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of absence_detail
        if self.absence_detail:
            _dict['absenceDetail'] = self.absence_detail.to_dict()
        # override the default output from pydantic by calling `to_dict()` of position
        if self.position:
            _dict['position'] = self.position.to_dict()
        # override the default output from pydantic by calling `to_dict()` of substitute
        if self.substitute:
            _dict['substitute'] = self.substitute.to_dict()
        # override the default output from pydantic by calling `to_dict()` of location
        if self.location:
            _dict['location'] = self.location.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in accounting_codes (list)
        _items = []
        if self.accounting_codes:
            for _item in self.accounting_codes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['accountingCodes'] = _items
        # override the default output from pydantic by calling `to_dict()` of pay_code
        if self.pay_code:
            _dict['payCode'] = self.pay_code.to_dict()
        # override the default output from pydantic by calling `to_dict()` of vacancy_reason
        if self.vacancy_reason:
            _dict['vacancyReason'] = self.vacancy_reason.to_dict()
        # override the default output from pydantic by calling `to_dict()` of verified_by
        if self.verified_by:
            _dict['verifiedBy'] = self.verified_by.to_dict()
        # set to None if notes_to_admin (nullable) is None
        # and __fields_set__ contains the field
        if self.notes_to_admin is None and "notes_to_admin" in self.__fields_set__:
            _dict['notesToAdmin'] = None

        # set to None if admin_only_notes (nullable) is None
        # and __fields_set__ contains the field
        if self.admin_only_notes is None and "admin_only_notes" in self.__fields_set__:
            _dict['adminOnlyNotes'] = None

        # set to None if assignment_id (nullable) is None
        # and __fields_set__ contains the field
        if self.assignment_id is None and "assignment_id" in self.__fields_set__:
            _dict['assignmentId'] = None

        # set to None if external_assignment_number (nullable) is None
        # and __fields_set__ contains the field
        if self.external_assignment_number is None and "external_assignment_number" in self.__fields_set__:
            _dict['externalAssignmentNumber'] = None

        # set to None if assignment_is_long_term (nullable) is None
        # and __fields_set__ contains the field
        if self.assignment_is_long_term is None and "assignment_is_long_term" in self.__fields_set__:
            _dict['assignmentIsLongTerm'] = None

        # set to None if assignment_notes (nullable) is None
        # and __fields_set__ contains the field
        if self.assignment_notes is None and "assignment_notes" in self.__fields_set__:
            _dict['assignmentNotes'] = None

        # set to None if accounting_codes (nullable) is None
        # and __fields_set__ contains the field
        if self.accounting_codes is None and "accounting_codes" in self.__fields_set__:
            _dict['accountingCodes'] = None

        # set to None if pay_unit (nullable) is None
        # and __fields_set__ contains the field
        if self.pay_unit is None and "pay_unit" in self.__fields_set__:
            _dict['payUnit'] = None

        # set to None if verified_at_utc (nullable) is None
        # and __fields_set__ contains the field
        if self.verified_at_utc is None and "verified_at_utc" in self.__fields_set__:
            _dict['verifiedAtUtc'] = None

        # set to None if verify_comment (nullable) is None
        # and __fields_set__ contains the field
        if self.verify_comment is None and "verify_comment" in self.__fields_set__:
            _dict['verifyComment'] = None

        # set to None if approval_status (nullable) is None
        # and __fields_set__ contains the field
        if self.approval_status is None and "approval_status" in self.__fields_set__:
            _dict['approvalStatus'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> VacancyDetailSearchResponse:
        """Create an instance of VacancyDetailSearchResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return VacancyDetailSearchResponse.parse_obj(obj)

        _obj = VacancyDetailSearchResponse.parse_obj({
            "notes_to_admin": obj.get("notesToAdmin"),
            "admin_only_notes": obj.get("adminOnlyNotes"),
            "absence_detail": SimpleAbsenceDetail.from_dict(obj.get("absenceDetail")) if obj.get("absenceDetail") is not None else None,
            "vacancy_id": obj.get("vacancyId"),
            "is_deleted": obj.get("isDeleted"),
            "position": SimplePosition.from_dict(obj.get("position")) if obj.get("position") is not None else None,
            "created_utc": obj.get("createdUtc"),
            "id": obj.get("id"),
            "assignment_id": obj.get("assignmentId"),
            "substitute": SimplePerson.from_dict(obj.get("substitute")) if obj.get("substitute") is not None else None,
            "external_assignment_number": obj.get("externalAssignmentNumber"),
            "assignment_is_long_term": obj.get("assignmentIsLongTerm"),
            "assignment_notes": obj.get("assignmentNotes"),
            "location": Int32IdNameClass.from_dict(obj.get("location")) if obj.get("location") is not None else None,
            "start": obj.get("start"),
            "end": obj.get("end"),
            "actual_duration_minutes": obj.get("actualDurationMinutes"),
            "accounting_codes": [AccountingCodeAllocationResponse.from_dict(_item) for _item in obj.get("accountingCodes")] if obj.get("accountingCodes") is not None else None,
            "pay_duration": obj.get("payDuration"),
            "pay_unit": obj.get("payUnit"),
            "pay_code": PayCodeResponse.from_dict(obj.get("payCode")) if obj.get("payCode") is not None else None,
            "vacancy_reason": Int32IdNameClass.from_dict(obj.get("vacancyReason")) if obj.get("vacancyReason") is not None else None,
            "verified": obj.get("verified"),
            "verified_at_utc": obj.get("verifiedAtUtc"),
            "verify_comment": obj.get("verifyComment"),
            "verified_by": Int32IdNameClass.from_dict(obj.get("verifiedBy")) if obj.get("verifiedBy") is not None else None,
            "approval_status": obj.get("approvalStatus"),
            "approval_status_id": obj.get("approvalStatusId")
        })
        return _obj


